#!/usr/local/bin/python 

from Numeric import *
from string import *
from gist import *
import KPDF

outfile = open("ratio","w")

### setup parameters
min_pro_len = 20 #minimum length of searching protein (aa)


# read *.fna file
genome = open("../../data/NC_000913.fna").read()
i = genome.index("\n")
genome = genome[i:]
genome = genome.replace("\n","")

indis = open("../../distance_dist/gap_len", "r")
dis = indis.readlines()
for i in range(len(dis)):
	dis[i] = dis[i].replace("\n","")
	dis[i] = float(dis[i])
dis = array(dis)
max_dis = 15
min_dis = -5
x = arange(min_dis,max_dis)
h = KPDF.UPDFOptimumBandwidth(dis)
y = KPDF.UPDFGaussian(dis,x,h)


#####################################################################################
def findstart(allseq,ter_pos):
	around_start_seq = []
	TLS_pos = []
	for i in range(len(allseq))[2:]:
		aaseq = allseq[ter_pos-i*3:ter_pos-i*3+3]
		if aaseq in ["ATG","GTG","TTG"]:
			if i > min_pro_len:
				around_start_seq.append(allseq[ter_pos-i*3-50:ter_pos-i*3+20])
				TLS_pos.append(ter_pos-i*3+1)
				
		elif aaseq in ["TAA","TAG","TGA"]:
			break
	return around_start_seq,TLS_pos

######################################################################################
def compl(seq):
	complseq = ""
	for c in range(len(seq)):
		complseq = complseq + seq[-c-1]
	complseq = complseq.replace("A","t")
	complseq = complseq.replace("T","a")
	complseq = complseq.replace("G","c")
	complseq = complseq.replace("C","g")
	complseq = swapcase(complseq)
	
	return complseq
########################################################################################
def cal_score(around_start_seq,TLS_pos,gene_name,TLS_end_pos,true_pos):
	max_sc = -100
	TLS_end_pos = int(TLS_end_pos)
	
	for ino in range(len(around_start_seq)):
		
		pro_len = (abs(TLS_pos[ino]-TLS_end_pos)+1)/3.
		longest = (abs(TLS_pos[-1]-TLS_end_pos)+1)/3.
		pro_ratio = pro_len/longest
		max_pos = TLS_pos[ino]
		
		if(true_pos == max_pos):
			outfile.write("%.3f\n" %(pro_ratio))
#			print "%s\t%.3f" %(gene_name,pro_ratio)

########################################################################################

genomecompl = compl(genome)
datasetfile = open("../../data/EG858_dataset","r")
dataset = datasetfile.readlines()
for k in range(len(dataset)):
	dataset[k] = dataset[k].replace("\n","")
	dataset[k] = dataset[k].split("\t")
	dataset[k][4] = dataset[k][4].split("..")
	if dataset[k][5] == "-":
		dataset[k][4][0] = int(dataset[k][4][0])
		TLS_end_pos = dataset[k][4][0]
		around_start_seq,TLS_pos = findstart(genomecompl,len(genomecompl)-dataset[k][4][0]+1)
		for kk in range(len(TLS_pos)):
			TLS_pos[kk] = len(genomecompl)-TLS_pos[kk]+1
		
	else:
		dataset[k][4][1] = int(dataset[k][4][1])
		TLS_end_pos = dataset[k][4][1]
		around_start_seq,TLS_pos = findstart(genome,dataset[k][4][1])
	
	if around_start_seq != []:
		each_score = cal_score(around_start_seq,TLS_pos,dataset[k][0],TLS_end_pos,int(dataset[k][6]))

