#!/usr/local/bin/perl -w
###
#
###
$BGa = 0.2461;
$BGt = 0.2461;
$BGg = 0.2539;
$BGc = 0.2539;
$seq = "";


$nex_folder = "align_nex";
opendir(DIR, $nex_folder) || die "Can't open $nex_folder :$!\n";
@nexs = grep /\.nex/, readdir(DIR);

foreach $nex (@nexs){
	$nexfile = $nex;
	$tf = $nexfile;
	$tf =~ s/\.nex//;
	$outfile = "align_matrix/$tf"."_0th.txt";

	open(NEX,"$nex_folder\/$nexfile") || die"Can't open $nexfile\n";
	open(OUT,">$outfile") || die"Can't open $outfile\n";

#	print OUT ">$tf\n";
	while(<NEX>){
		next unless(/Matrix/);
	
		$fg = 0;
		while(<NEX>){
			last if(/^\;/);
			next if(/\[.+\]/);
			if(/\s+\S+\s+\S+/){
				$N ++;	#the number of sequeces
				($seq) = /\s+\S+\s+(\S+)$/;
				$len = length $seq;
#	print "seq\t$seq\n";
				#initialize
				if($fg == 0){
					$fg = 1;
					foreach $i (0..$len-1){
						$A[$i] = $C[$i] = $G[$i] = $T[$i] = $fg[$i] = 0;
					}
				}
				foreach $i (0..$len-1){
					$seqNT = substr($seq,$i,1);
					$A[$i]++ if($seqNT eq "A");
					$C[$i]++ if($seqNT eq "C");
					$G[$i]++ if($seqNT eq "G");
					$T[$i]++ if($seqNT eq "T");
					$fg[$i] = 1 if($seqNT eq "N");
				}
			}
		}
		
		#$B = log($N);
		$B = 1;
		foreach $i (0..$len-1){
			$Sa = log((($A[$i]+$B*$BGa)/($N+$B)) / $BGa);
			$Sc = log((($C[$i]+$B*$BGc)/($N+$B)) / $BGc);
			$Sg = log((($G[$i]+$B*$BGg)/($N+$B)) / $BGg);
			$St = log((($T[$i]+$B*$BGt)/($N+$B)) / $BGt);	
			printf OUT "%.4f\t%.4f\t%.4f\t%.4f\n", $Sa,$Sc,$Sg,$St if($fg[$i] == 0);
			print OUT "0\t0\t0\t0\n" if($fg[$i] == 1);
			$Sa = $Sc = $Sg = $St = 0;
		}
	}
#	print OUT "//\n";
	$N = $B = 0;

}