#!/usr/local/bin/python 
###
# calculate 2nd-order Mrakov model
#	base order : ACGT
###
from Numeric import *

BG={}
#Background probabilit in Ecoli: 0th order Markov Model
BG["A"] = 0.2461
BG["C"] = 0.2539
BG["G"] = 0.2539
BG["T"] = 0.2461
#Background probabilit in Ecoli: 1st order Markov Model
BG["AA"] = 0.0730
BG["AC"] = 0.0552
BG["AG"] = 0.0511
BG["AT"] = 0.0668
BG["CA"] = 0.0698
BG["CC"] = 0.0584
BG["CG"] = 0.0747
BG["CT"] = 0.0511
BG["GA"] = 0.0576
BG["GC"] = 0.0827
BG["GG"] = 0.0584
BG["GT"] = 0.0552
BG["TA"] = 0.0457
BG["TC"] = 0.0576
BG["TG"] = 0.0698
BG["TT"] = 0.0730
#Background probabilit in Ecoli: 2nd order Markov Model
BG["AAA"] = 0.0236
BG["AAC"] = 0.0178
BG["AAG"] = 0.0137
BG["AAT"] = 0.0179
BG["ACA"] = 0.0126
BG["ACC"] = 0.0161
BG["ACG"] = 0.0158
BG["ACT"] = 0.0107
BG["AGA"] = 0.0121
BG["AGC"] = 0.0174
BG["AGG"] = 0.0109
BG["AGT"] = 0.0107
BG["ATA"] = 0.0137
BG["ATC"] = 0.0186
BG["ATG"] = 0.0165
BG["ATT"] = 0.0179
BG["CAA"] = 0.0166
BG["CAC"] = 0.0143
BG["CAG"] = 0.0224
BG["CAT"] = 0.0165
BG["CCA"] = 0.0185
BG["CCC"] = 0.0103
BG["CCG"] = 0.0187
BG["CCT"] = 0.0109
BG["CGA"] = 0.0154
BG["CGC"] = 0.0248
BG["CGG"] = 0.0187
BG["CGT"] = 0.0158
BG["CTA"] = 0.0058
BG["CTC"] = 0.0092
BG["CTG"] = 0.0224
BG["CTT"] = 0.0137
BG["GAA"] = 0.0180
BG["GAC"] = 0.0117
BG["GAG"] = 0.0092
BG["GAT"] = 0.0186
BG["GCA"] = 0.0206
BG["GCC"] = 0.0199
BG["GCG"] = 0.0248
BG["GCT"] = 0.0174
BG["GGA"] = 0.0121
BG["GGC"] = 0.0199
BG["GGG"] = 0.0103
BG["GGT"] = 0.0161
BG["GTA"] = 0.0113
BG["GTC"] = 0.0117
BG["GTG"] = 0.0143
BG["GTT"] = 0.0178
BG["TAA"] = 0.0148
BG["TAC"] = 0.0113
BG["TAG"] = 0.0058
BG["TAT"] = 0.0137
BG["TCA"] = 0.0181
BG["TCC"] = 0.0121
BG["TCG"] = 0.0154
BG["TCT"] = 0.0121
BG["TGA"] = 0.0181
BG["TGC"] = 0.0206
BG["TGG"] = 0.0185
BG["TGT"] = 0.0126
BG["TTA"] = 0.0148
BG["TTC"] = 0.0180
BG["TTG"] = 0.0166
BG["TTT"] = 0.0236

#initialization
N = {}
S = {}
for x in "ACGT":
	for y in "ACGT":
		N[x+y] = zeros(32,Float)
		S[x+y] = zeros(32,Float)
		for z in "ACGT":
			N[x+y+z] = zeros(32,Float)
			S[x+y+z] = zeros(32,Float)

outfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_matrix/align_up30.txt","w")
#outfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_matrix/align_dw20.txt","w")
nexfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_nex/align_up32.nex","r")
#nexfile = open("/Users/yukomakita/Desktop/EcoGene_2ndMM/make_PSSM/align_nex/align_dw22.nex","r")
nexdata = nexfile.readlines()
nexdata = nexdata[8:-4]

for i in range (len(nexdata)):
	nexdata[i] = nexdata[i].replace("\n","")
	nexdata[i] = nexdata[i].replace("\t","")
	nexdata[i] = nexdata[i].split(" ")
	for j in range(len(nexdata[i][1])-2):
		
		for x in "ACGT":
			for y in "ACGT":
				if(nexdata[i][1][j:j+2] == x+y):
					N[x+y][j] += 1
				
				for z in "ACGT":
					if(nexdata[i][1][j:j+3] == x+y+z):
						N[x+y+z][j] += 1

tnum = len(nexdata)
B = sqrt(tnum)
#B = 1
printout = ""
for i in range(len(nexdata[0][1])-2):
	for x in "ACGT":
		for y in "ACGT":
			S[x+y][i] = log(((N[x+y][i]+B*BG[x+y])/(tnum+B)) / BG[x+y])
	
	for x in "ACGT":
		for y in "ACGT":
			for z in "ACGT":
				S[x+y+z][i] = log(((N[x+y+z][i]+B*BG[x+y+z])/(tnum+B)) / BG[x+y+z]) - S[x+y][i]
				printout = printout + "%.4f\t" % (S[x+y+z][i])
	printout = printout[:-1]	#remove the last tab(\t)
	printout = printout + "\n"
printout = printout[:-1]	#remove the last return(\n)
outfile.write(printout)
